#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>

#ifndef F_SETLEASE
#define F_SETLEASE 1024
#endif

void do_sigio(int signo, siginfo_t *siginfo, void *_)
{
	int code = siginfo->si_code;
	int fd = siginfo->si_fd;
	printf("Signal number %d, code %d, fd = %d\n", signo, code, fd);
	if (code != 3)
		return;
	sleep(5);
	fcntl(fd, F_SETLEASE, F_UNLCK);
}

int main(int argc, char **argv)
{
	int fd;
	struct sigaction sigio;

	sigio.sa_sigaction = do_sigio;
	sigio.sa_flags = SA_SIGINFO;
	sigaction(SIGIO, &sigio, NULL);

	printf("Setting lease on %s\n", argv[1]);
	fd = open(argv[1], O_RDWR, 0777);
	fcntl(fd, F_SETSIG, SIGIO);
	fcntl(fd, F_SETLEASE, F_WRLCK);

	for (;;) {
		pause();
		printf("signal handler returned\n");
	}
	return 0;
}
